VMPlugin (groovy 2.4.16 API)
Date: 2018-12-09

Package: org.codehaus.groovy.vmplugin

## [Java] Interface VMPlugin

- Interface to access VM version based actions. This interface is for internal use only!

  Authors:
    Jochen Theodorou

- - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `void` | `configureAnnotation(AnnotationNode an)`
    `` | `void` | `configureClassNode(CompileUnit compileUnit, ClassNode classNode)`
    `` | `Object` | `getInvokeSpecialHandle(Method m, Object receiver)` Returns a handle with bound receiver to invokeSpecial the given method.
    `` | `Class[]` | `getPluginDefaultGroovyMethods()`
    `` | `Class[]` | `getPluginStaticGroovyMethods()`
    `` | `int` | `getVersion()` Gives the version the plguin is made for
    `` | `void` | `invalidateCallSites()`
    `` | `Object` | `invokeHandle(Object handle, Object[] args)` Invokes a handle produced by #getInvokeSpecialdHandle
    `` | `void` | `setAdditionalClassInformation(ClassNode c)`

- - ### Method Detail

    - #### public void configureAnnotation(AnnotationNode an)

    - #### public void configureClassNode(CompileUnit compileUnit, ClassNode classNode)

    - #### public Object getInvokeSpecialHandle(Method m, Object receiver)

      Returns a handle with bound receiver to invokeSpecial the given method. This method will require at least Java 7, but since the source has to compile on older Java versions as well it is not marked to return a MethodHandle and uses Object instead

      Returns:
        null in case of jdk<7, otherwise a handle that takes the method call arguments for the invokespecial call

    - #### public Class[] getPluginDefaultGroovyMethods()

    - #### public Class[] getPluginStaticGroovyMethods()

    - #### public int getVersion()

      Gives the version the plguin is made for

      Returns:
        5 for jdk5, 6 for jdk6, 7 for jdk7 or higher

    - #### public void invalidateCallSites()

    - #### public Object invokeHandle(Object handle, Object[] args)

      Invokes a handle produced by #getInvokeSpecialdHandle

      Parameters:
        `handle` - the handle
        `args` - arguments for the method call, can be empty but not null
      Returns:
        the result of the method call

    - #### public void setAdditionalClassInformation(ClassNode c)